SystemOrganization addCategory: #Proxies!

!CompiledMethod methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 21:58'!
mareaPrintString 
	^ self methodClass asString, '>>', self selector.! !

ProtoObject subclass: #ClassProxyInstVar
	instanceVariableNames: 'superclass methodDict format actualClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:04'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 10/1/2010 14:57'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
	actualClass := self! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
restore
	self mareaLog: 'Will restore class'.
	self become: actualClass.
	self mareaLog: 'Class restored'.
! !

ProtoObject subclass: #CompiledMethodProxyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

CompiledMethodProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

CompiledMethodProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/24/2010 18:39'!
mareaCheckLoop
	| stack ctxt  set  runWithInMethodProxy runWithInMethodProxyReceiver proxySender found |
	stack := OrderedCollection new.
	ctxt := thisContext.
	
	runWithInMethodProxy := ctxt sender sender method.
	runWithInMethodProxyReceiver :=  ctxt sender sender receiver. 
	proxySender := ctxt sender sender sender method.
	
"	ToolSet inspect: ctxt sender sender sender label: 'where to start'. 
	ToolSet inspect: runWithInMethodProxy label: 'runWithInMethodProxy'.
	ToolSet inspect: runWithInMethodProxyReceiver label: 'runWithInMethodProxyReceiver'.
	ToolSet inspect: proxySender label: 'proxySender'."
	
	found := ctxt sender sender sender findContextSuchThat: [:aContext | 
	(aContext sender isNil not) and:  [
		(aContext sender method == proxySender) 
		and: [
			(runWithInMethodProxyReceiver == aContext receiver)
				and: [aContext method == runWithInMethodProxy ]]
	]].
	
	found isNil ifFalse: [ self mareaLog: 'LOOP ---- '. CompiledMethodPossibleLoopDetection signal: 'It is possible that a proxy that was needed to swap is, was swapped out'.  ].
	! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 11:46'!
mareaFileName
	^ self asString, '.swap'! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/24/2010 11:52'!
mareaHandleDoesNotUnderstand: aMessage forProxy: aProxy

	| oldMethod answer |
	self mareaLog: 'CompiledMethodProxyReferenceStream dnu: ', aMessage selector.
	oldMethod := self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := oldMethod perform: aMessage selector withArguments: aMessage arguments.
	self mareaLog: 'The message was sent to the original object'.
	^ answer.! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/24/2010 18:29'!
mareaHandleRun: aSelector with: arguments in: aReceiver forProxy: aProxy
	| aResult oldMethod |
	self mareaCheckLoop.
	self mareaLog: 'The method ', aSelector, ' is being executed'.
	oldMethod := self mareaUninstallForProxy: aProxy.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self mareaLog: 'The method ', aSelector, ' was executed'.
	^aResult
	! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/24/2010 12:44'!
mareaInstallFor: aMethodReference andProxy: anObject
	| oldMethod oldClass selector |
	oldClass := aMethodReference actualClass. 
	selector := aMethodReference  selector. 
	[oldMethod := oldClass lookupSelector: selector.
	"The other alternative is being able to create proxies for profies, but the proxy handlers expect a CompiledMethod and not a proxy."
	oldMethod isKindOf: anObject class] whileTrue: [oldMethod mareaUninstall].
	self mareaLog: 'The method ', selector asString, ' is being wrapped'.
	self mareaWriteMethodOnDisk: oldMethod andProxy: anObject.
	oldClass methodDict at: selector put: anObject.! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:39'!
mareaLoadCompiledMethodFor: aProxy
	^ self mareaMethodSerializer mareaUnserializeMethodFrom: aProxy mareaFileName
	! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:46'!
mareaMethodSerializer
	^ self mareaSerializer new! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/24/2010 12:13'!
mareaRemoveFile: aFileName
	FileDirectory default deleteFileNamed: aFileName
	
! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:46'!
mareaSerializer
	MareaSerializer isNil ifTrue: [ReferenceStreamMareaSerializer].
	^ MareaSerializer! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:47'!
mareaSerializer: aMareaSerializer
	MareaSerializer := aMareaSerializer! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/24/2010 12:39'!
mareaUninstallForProxy: aProxy
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [^ nil].
	oldMethod := self mareaLoadCompiledMethodFor: aProxy.
	self mareaLog: 'The CompiledMethod ', oldMethod asString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod asString, ' was uninstalled.'.
	self mareaRemoveFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

!CompiledMethodProxyHandler classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:59'!
mareaWriteMethodOnDisk: aCompiledMethod andProxy: aProxy
	| refStream fileName | 
	fileName := (aProxy mareaFileNameForMethod: aCompiledMethod).
	[ fileName := fileName, '.swap' ] 
		doWhileTrue: [(FileDirectory default isAFileNamed: fileName)].
	self mareaMethodSerializer mareaSerializeAndWriteMethod: aCompiledMethod to: fileName.
	aProxy mareaStoreFileNameIfNecessary: fileName. 
	self mareaLog: 'The method ', aCompiledMethod selector asString, ' was written on file named: ', self asString.

! !

ProtoObject subclass: #ObjectProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 15:39'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:51'!
forFileName: aFileName
	^ self new fileName: aFileName ! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 17:29'!
initialize
	"With this, The compiler does not associate #class with a special bytecode. Then, we can use #class like a normal message. So we can for example, override its behavior."
	(ParseNode classVarNamed:  'StdSelectors') removeKey: #class ifAbsent: [].! !

!ObjectProxy methodsFor: 'proxy' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
become: anObject
	self mareaSerializeAndWriteToDisk: anObject.
	"anObject becomeForward: self. "
	super become: anObject. ! !

!ObjectProxy methodsFor: 'catching' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
doesNotUnderstand: aMessage
	self mareaLog: 'Message not understood:', aMessage asString.
	self mareaLog: 'Will restore object'.
	self become: self mareaLoadBackSerializedObjectsFromFile.
	self mareaLog: 'Object was restored'.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaLoadBackSerializedObjectsFromFile

	| file result |
	file := FileStream fileNamed: fileName.
	file binary.
	result := (ReferenceStream on: file) next.
	file close.
	^ result! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject	
	| file result |
	fileName := (DateAndTime now asString, '.swap').
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 10/20/2010 11:33'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 19:53'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:01'!
mareaAt: key 
	"Answer the value associated with the key."

	^ self mareaAt: key ifAbsent: [self errorKeyNotFound]! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:00'!
mareaAt: key ifAbsent: aBlock

	| index |
	index := self findElementOrNil: key.
	(self basicAt: index) == nil ifTrue: [ ^ aBlock value ].
	^ array at: index! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 17:36'!
initialize 
	self class addInstVarName: 'CurrentNumber'.
	self class addInstVarName: 'IsRunnintTests'.
	CurrentNumber := 0.! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 17:38'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := false].
	^ IsRunnintTests ! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 15:41'!
mareaNextNumber
	CurrentNumber isNil ifTrue: [ CurrentNumber := 0 ].
	CurrentNumber := CurrentNumber + 1.
	^ CurrentNumber
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 18:28'!
on: aMethodReference
	^self mareaNextNumber mareaInstallFor: aMethodReference 
	! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 17:37'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 19:51'!
class
	(self mareaClass isRunningTest)
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self mareaUninstall class ].! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 11:52'!
doesNotUnderstand: aMessage
	self mareaIsProxyInstalled 
		ifTrue: [ ^ CompiledMethodProxyHandler mareaHandleDoesNotUnderstand: aMessage forProxy: self]
		ifFalse: [ ^ super doesNotUnderstand: aMessage ].
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 22:58'!
flushCache
	"I cannot do anything here because otherwise it crash the VM"! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 11:26'!
mareaFileName
	^ self asString, '.swap'! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 12:02'!
mareaFileNameForMethod: aCompiledMethod
	^ self asString! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 15:14'!
mareaInstallFor: aMethodReference
	CompiledMethodProxyHandler mareaInstallFor: aMethodReference andProxy: self
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 11:36'!
mareaIsProxyInstalled 
	^ FileDirectory default isAFileNamed: self mareaFileName! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 12:15'!
mareaMarkAsUninstalled
	"We don't need to do anything for SmallInteger since to detect if it is uninstalled we check the existance off the file, which is removed during the uninstall'"! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 12:15'!
mareaStoreFileNameIfNecessary: aFileName! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 15:14'!
mareaUninstall
	^ CompiledMethodProxyHandler mareaUninstallForProxy: self
! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 16:34'!
run: aSelector with: arguments in: aReceiver
	^ CompiledMethodProxyHandler mareaHandleRun: aSelector with: arguments in: aReceiver forProxy: self
	! !

Error subclass: #CompiledMethodPossibleLoopDetection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

Object subclass: #ClassProxyFileOut
	instanceVariableNames: 'superclass methodDict format className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/17/2010 17:02'!
become: aClass
	| classNameBkp |
	className := aClass name.
	"FileDirectory default  deleteFileNamed: aClass name, '.st'  ifAbsent: [].
	"aClass fileOut.
	"Smalltalk removeClassNamed: className.
	"
	super become: aClass
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:49'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:52'!
fileInClass.
	(FileStream fileNamed: className, '.st') fileIn.
	^ Smalltalk at: className. 
	! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:50'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
restore
	self mareaLog: 'Will restore class'.
	super become: self fileInClass.
	self mareaLog: 'Class restored'.
! !

Object subclass: #CompiledMethodProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

CompiledMethodProxy class
	instanceVariableNames: 'IsRunnintTests'!

CompiledMethodProxy class
	instanceVariableNames: 'IsRunnintTests'!

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/23/2010 11:52'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/23/2010 17:22'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := false].
	^ IsRunnintTests ! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/23/2010 11:52'!
on: aMethodReference
	^self new mareaInstallFor: aMethodReference ! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/23/2010 11:52'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/23/2010 17:31'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!CompiledMethodProxy methodsFor: 'evaluation' stamp: 'MarianoMartinezPeck 11/23/2010 19:50'!
class
	(self mareaClass isRunningTest)
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self mareaUninstall class ].! !

!CompiledMethodProxy methodsFor: 'catching' stamp: 'MarianoMartinezPeck 11/24/2010 11:51'!
doesNotUnderstand: aMessage
	self mareaIsProxyInstalled 
		ifTrue: [ ^ CompiledMethodProxyHandler mareaHandleDoesNotUnderstand: aMessage forProxy: self]
		ifFalse: [ ^ super doesNotUnderstand: aMessage ].
	
	

! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/23/2010 11:58'!
flushCache
! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/23/2010 12:05'!
mareaFileName
	^ fileName! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/23/2010 12:06'!
mareaFileNameForMethod: aCompiledMethod
	^ aCompiledMethod mareaPrintString! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/23/2010 15:16'!
mareaInstallFor: aMethodReference
	CompiledMethodProxyHandler mareaInstallFor: aMethodReference andProxy: self
	! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/24/2010 11:33'!
mareaIsProxyInstalled
	^ fileName isNil not! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/24/2010 12:10'!
mareaMarkAsUninstalled
	fileName := nil.! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/23/2010 12:15'!
mareaStoreFileNameIfNecessary: aFileName
	fileName := aFileName! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 11/23/2010 15:16'!
mareaUninstall
	^ CompiledMethodProxyHandler mareaUninstallForProxy: self
! !

!CompiledMethodProxy methodsFor: 'evaluation' stamp: 'MarianoMartinezPeck 11/23/2010 15:16'!
run: aSelector with: arguments in: aReceiver
	^ CompiledMethodProxyHandler mareaHandleRun: aSelector with: arguments in: aReceiver forProxy: self
	! !

Object subclass: #CompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: 'ProxyClass'
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 22:39'!
classesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := (ClassBuilder new tooDangerousClasses) collect: [:each | Smalltalk at: each].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. Class. Message. MethodDictionary.}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they install the segment (they are used) even before the segment can be written into a file"
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet.}.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses.
	
	^ allClasses asOrderedCollection ! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 22:40'!
compiledMethodsToSwap
	| minimalCompiledMethods methodsToSwap classesNotToSwap packagesNotToSwap |
	
	UnusedObjectDiscoverer current startDiscovery. 
	
	minimalCompiledMethods := self discoverMinimalUsedCompiledMethods.
	
	packagesNotToSwap := self packagesNotToSwap.
	
	classesNotToSwap := self classesNotToSwap.
	packagesNotToSwap do: [:aPackage | classesNotToSwap addAll: aPackage classes ].
	
	classesNotToSwap do: [:aClass | aClass markAllCompiledMethodsAsUsed].
	
	UnusedObjectDiscoverer current stopDiscovery.
	
	methodsToSwap := CompiledMethod unusedInstances.
	Transcript show: 'Methods to swap: ',  methodsToSwap size asString; cr.
	Transcript show: 'Methods NOT to swap: ',  CompiledMethod usedInstances size asString; cr.
	
	^ methodsToSwap


! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 22:21'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	SystemNavigation default browseClass: Object.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	aProxy mareaUninstall.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.
	aProxy mareaUninstall.
! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
installOn: aClass selector:  aSelector.
	^ self proxyClass installOn: aClass selector: aSelector.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfNotDangerousCorePackages
	^ self listOfNotDangerousCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 21:40'!
listOfNotDangerousCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^ #('Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'Gofer-Core' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'System-Change Notification' 'System' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'System-Serial Port' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'System-FileRegistry' 'ToolBuilder-SUnit' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'Settings-Monticello' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 20:45'!
nose 
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxyHandler mareaSerializer: ReferenceStreamMareaSerializer. 
	self proxyClass: SmallInteger.
	MareaLogger changeToFileLogger.
	3 timesRepeat: [Smalltalk garbageCollect].
	Transcript show: 'Using proxy class: ', self proxyClass name; cr.
	Transcript show: 'Proxy instances before start: ', self proxyClass instanceCount asString; cr.
	Transcript show: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString; cr.
	Transcript show: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString; cr.
"	methodsToSwap := self compiledMethodsToSwap.
	"
	methodsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			methodsToSwap addAll: aClass unusedMethods
			].
		].
	
	Transcript show: 'CompiledMethods to swap: ',  methodsToSwap size asString; cr.
	timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| self installOn: method methodClass selector: method selector.].
	].
	Transcript show: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'; cr.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	Transcript show: 'Proxy instances after installing: ', self proxyClass instanceCount asString; cr.
	Transcript show: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString; cr.
	Transcript show: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString; cr.
	timeToUninstall := MessageTally time: [self proxyClass allInstances do: [:each | each mareaUninstall]].
	Transcript show: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'; cr.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	Transcript show: 'Proxy instances after uninstalling: ', self proxyClass instanceCount asString; cr.
	Transcript show: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString; cr.
	Transcript show: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString; cr.
	(FileDirectory default fileNamesMatching: '*.swap') 
	do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/19/2010 20:02'!
nose2 
	| minimalCompiledMethods |
	minimalCompiledMethods := self discoverMinimalUsedCompiledMethods.
	TestRunner methods do: [ :aMethod |
			CompiledMethodProxyReferenceStream installOn: TestRunner selector: aMethod selector.
			]. 
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 22:38'!
packagesNotToSwap.

	"These classes cannot be swapped out because they are needed by ...."
	^ # ('System-Object Storage' 'Fuel' ) collect: [:aPackageName | PackageInfo named: aPackageName]
	! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:24'!
proxyClass
	^ ProxyClass! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:25'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

Object subclass: #MareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

MareaSerializer subclass: #FuelMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!FuelMareaSerializer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:42'!
mareaSerializeAndWriteMethod: aCompiledMethod to: aFileName
	| serializer aFileStream | 
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	serializer := FLSerializer on: aFileStream.
	serializer serialize: aCompiledMethod.
	aFileStream close.
	self mareaLog: 'The method ', aCompiledMethod selector asString, ' was written on file'.
! !

!FuelMareaSerializer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:40'!
mareaUnserializeMethodFrom: aFileName
	| materializer aCompiledMethod aFileStream |
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	materializer := FLMaterializer on: aFileStream.
	materializer materialize.
	aFileStream close.
	^ materializer root
! !

!MareaSerializer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:42'!
mareaSerializeAndWriteMethod: aCompiledMethod to: aFileName
	self shouldBeImplemented ! !

!MareaSerializer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:39'!
mareaUnserializeMethodFrom: aFileName
	self shouldBeImplemented ! !

MareaSerializer subclass: #ReferenceStreamMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ReferenceStreamMareaSerializer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:42'!
mareaSerializeAndWriteMethod: aCompiledMethod to: aFileName
	| refStream | 
	refStream := ReferenceStream fileNamed: aFileName.
	refStream nextPut: aCompiledMethod.
	refStream close.
	self mareaLog: 'The method ', aCompiledMethod selector asString, ' was written on file'.
! !

!ReferenceStreamMareaSerializer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/23/2010 14:39'!
mareaUnserializeMethodFrom: aFileName
	| refStream aCompiledMethod |
	refStream := ReferenceStream fileNamed: aFileName.
	aCompiledMethod := refStream next.
	refStream close.
	^ aCompiledMethod! !

Object subclass: #ObjectSwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/21/2010 18:26'!
fileName
	^ DateAndTime now asString , '.swap'! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject
	| file fileName result |
	fileName := self fileName.
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ fileName! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
swap: anObject
	| fileName proxy |
	fileName := self mareaSerializeAndWriteToDisk: anObject. 
	
	"make this nicer"
	anObject isBehavior 
		ifTrue: [proxy := AClassProxy forFileName: fileName.]
		ifFalse: [proxy := ObjectProxy forFileName: fileName.].
	
	anObject becomeForward: proxy. ! !

Object subclass: #ProxySuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ProxySuperclass methodsFor: 'swapping' stamp: 'NouryBouraqadi 10/1/2010 15:08'!
cannotInterpret: aMessage
	Transcript cr; 
		show: 'cannotInterpret:';
		space;
		show: aMessage selector..
	self class restore.
	^aMessage sendTo: self! !
SmallInteger initialize!
ObjectProxy initialize!
